Index: kern/kern_time.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_time.c,v
retrieving revision 1.13
diff -u -r1.13 kern_time.c
--- kern/kern_time.c	7 Jan 2004 11:08:06 -0000	1.13
+++ kern/kern_time.c	27 Jan 2004 02:40:54 -0000
@@ -52,6 +52,7 @@
 #include <vm/vm.h>
 #include <vm/vm_extern.h>
 #include <sys/msgport2.h>
+#include <sys/thread2.h>
 
 struct timezone tz;
 
@@ -71,8 +72,8 @@
 static void	timevalfix (struct timeval *);
 static void	no_lease_updatetime (int);
 
-static int	sleep_hardloop = 0;
-SYSCTL_INT(_kern, OID_AUTO, sleep_hardloop, CTLFLAG_RW, &sleep_hardloop, 0, "");
+static int     sleep_hard_us = 100;
+SYSCTL_INT(_kern, OID_AUTO, sleep_hard_us, CTLFLAG_RW, &sleep_hard_us, 0, "")
 
 static void 
 no_lease_updatetime(deltat)
@@ -89,9 +90,8 @@
 	struct timeval delta, tv1, tv2;
 	static struct timeval maxtime, laststep;
 	struct timespec ts;
-	int s;
 
-	s = splclock();
+	crit_enter();
 	microtime(&tv1);
 	delta = *tv;
 	timevalsub(&delta, &tv1);
@@ -122,7 +122,7 @@
 			}
 		} else {
 			if (tv1.tv_sec == laststep.tv_sec) {
-				splx(s);
+				crit_exit();
 				return (EPERM);
 			}
 			if (delta.tv_sec > 1) {
@@ -135,10 +135,9 @@
 
 	ts.tv_sec = tv->tv_sec;
 	ts.tv_nsec = tv->tv_usec * 1000;
-	set_timecounter(&ts);
-	(void) splsoftclock();
+	set_timeofday(&ts);
 	lease_updatetime(delta.tv_sec);
-	splx(s);
+	crit_exit();
 	resettodr();
 	return (0);
 }
@@ -195,20 +194,45 @@
 		 * Rounding up is especially important if rounding down
 		 * would give 0.  Perfect rounding is unimportant.
 		 */
-		ts.tv_nsec = 1000000000 / timecounter->tc_frequency + 1;
+		ts.tv_nsec = 1000000000 / cputimer_freq + 1;
 		error = copyout(&ts, SCARG(uap, tp), sizeof(ts));
 	}
 	return (error);
 }
 
-static int nanowait;
+/*
+ * nanosleep1()
+ *
+ *	This is a general helper function for nanosleep() (aka sleep() aka
+ *	usleep()).
+ *
+ *	If there is less then one tick's worth of time left and
+ *	we haven't done a yield, or the remaining microseconds is
+ *	ridiculously low, do a yield.  This avoids having
+ *	to deal with systimer overheads when the system is under
+ *	heavy loads.  If we have done a yield already then use
+ *	a systimer and an uninterruptable thread wait.
+ *
+ *	If there is more then a tick's worth of time left,
+ *	calculate the baseline ticks and use an interruptable
+ *	tsleep, then handle the fine-grained delay on the next
+ *	loop.  This usually results in two sleeps occuring, a long one
+ *	and a short one.
+ */
+static void
+ns1_systimer(systimer_t info)
+{
+	lwkt_schedule(info->data);
+}
 
 static int
 nanosleep1(struct timespec *rqt, struct timespec *rmt)
 {
+	static int nanowait;
 	struct timespec ts, ts2, ts3;
 	struct timeval tv;
 	int error;
+	int tried_yield;
 
 	if (rqt->tv_nsec < 0 || rqt->tv_nsec >= 1000000000)
 		return (EINVAL);
@@ -217,34 +241,36 @@
 	nanouptime(&ts);
 	timespecadd(&ts, rqt);		/* ts = target timestamp compare */
 	TIMESPEC_TO_TIMEVAL(&tv, rqt);	/* tv = sleep interval */
+	tried_yield = 0;
+
 	for (;;) {
-		/*
-		 * If hard looping is allowed and the interval is too short,
-		 * hard loop with a yield, otherwise sleep with a conservative
-		 * tick count.  In normal mode sleep with one extra tick count
-		 * which will be sufficient for most sleep values.  If it
-		 * isn't sufficient in normal mode we will wind up doing an
-		 * extra loop.
-		 *
-		 * sleep_hardloop = 0	Normal mode
-		 * sleep_hardloop = 1	Strict hard loop
-		 * sleep_hardloop = 2	Hard loop on < 1 tick requests only
-		 */
-		int ticks = tvtohz_low(&tv);
+		int ticks;
+		struct systimer info;
+
+		ticks = tv.tv_usec / tick;	/* approximate */
 
-		if (sleep_hardloop) {
-			if (ticks == 0) {
+		if (tv.tv_sec == 0 && ticks == 0) {
+			if (tried_yield || tv.tv_usec < sleep_hard_us) {
+				tried_yield = 0;
 				uio_yield();
-				error = iscaught(curproc);
 			} else {
-				error = tsleep(&nanowait, PCATCH, "nanslp", 
-						ticks + sleep_hardloop - 1);
+				crit_enter();
+				systimer_init_oneshot(&info, ns1_systimer,
+						curthread, tv.tv_usec);
+				lwkt_deschedule_self();
+				crit_exit();
+				lwkt_switch();
+				systimer_del(&info); /* make sure it's gone */
 			}
+			error = iscaught(curproc);
+		} else if (tv.tv_sec == 0) {
+			error = tsleep(&nanowait, PCATCH, "nanslp", ticks);
 		} else {
-			error = tsleep(&nanowait, PCATCH, "nanslp", ticks + 1);
+			ticks = tvtohz_low(&tv); /* also handles overflow */
+			error = tsleep(&nanowait, PCATCH, "nanslp", ticks);
 		}
 		nanouptime(&ts2);
-		if (error != EWOULDBLOCK) {
+		if (error && error != EWOULDBLOCK) {
 			if (error == ERESTART)
 				error = EINTR;
 			if (rmt != NULL) {
@@ -403,7 +429,7 @@
 	struct thread *td = curthread;
 	struct timeval atv;
 	long ndelta, ntickdelta, odelta;
-	int s, error;
+	int error;
 
 	if ((error = suser(td)))
 		return (error);
@@ -433,11 +459,14 @@
 	 */
 	if (ndelta < 0)
 		ntickdelta = -ntickdelta;
-	s = splclock();
+	/* 
+	 * XXX not MP safe , but will probably work anyway.
+	 */
+	crit_enter();
 	odelta = timedelta;
 	timedelta = ndelta;
 	tickdelta = ntickdelta;
-	splx(s);
+	crit_exit();
 
 	if (uap->olddelta) {
 		atv.tv_sec = odelta / 1000000;
@@ -476,11 +505,10 @@
 	struct proc *p = curproc;
 	struct timeval ctv;
 	struct itimerval aitv;
-	int s;
 
 	if (uap->which > ITIMER_PROF)
 		return (EINVAL);
-	s = splclock(); /* XXX still needed ? */
+	crit_enter();
 	if (uap->which == ITIMER_REAL) {
 		/*
 		 * Convert from absolute to relative time in .it_value
@@ -496,9 +524,10 @@
 			else
 				timevalsub(&aitv.it_value, &ctv);
 		}
-	} else
+	} else {
 		aitv = p->p_stats->p_timer[uap->which];
-	splx(s);
+	}
+	crit_exit();
 	return (copyout((caddr_t)&aitv, (caddr_t)uap->itv,
 	    sizeof (struct itimerval)));
 }
@@ -511,7 +540,7 @@
 	struct timeval ctv;
 	struct itimerval *itvp;
 	struct proc *p = curproc;
-	int s, error;
+	int error;
 
 	if (uap->which > ITIMER_PROF)
 		return (EINVAL);
@@ -530,7 +559,7 @@
 		timevalclear(&aitv.it_interval);
 	else if (itimerfix(&aitv.it_interval))
 		return (EINVAL);
-	s = splclock(); /* XXX: still needed ? */
+	crit_enter();
 	if (uap->which == ITIMER_REAL) {
 		if (timevalisset(&p->p_realtimer.it_value))
 			untimeout(realitexpire, (caddr_t)p, p->p_ithandle);
@@ -540,9 +569,10 @@
 		getmicrouptime(&ctv);
 		timevaladd(&aitv.it_value, &ctv);
 		p->p_realtimer = aitv;
-	} else
+	} else {
 		p->p_stats->p_timer[uap->which] = aitv;
-	splx(s);
+	}
+	crit_exit();
 	return (0);
 }
 
@@ -564,7 +594,6 @@
 {
 	struct proc *p;
 	struct timeval ctv, ntv;
-	int s;
 
 	p = (struct proc *)arg;
 	psignal(p, SIGALRM);
@@ -573,7 +602,7 @@
 		return;
 	}
 	for (;;) {
-		s = splclock(); /* XXX: still neeeded ? */
+		crit_enter();
 		timevaladd(&p->p_realtimer.it_value,
 		    &p->p_realtimer.it_interval);
 		getmicrouptime(&ctv);
@@ -582,10 +611,10 @@
 			timevalsub(&ntv, &ctv);
 			p->p_ithandle = timeout(realitexpire, (caddr_t)p,
 			    tvtohz_low(&ntv));
-			splx(s);
+			crit_exit();
 			return;
 		}
-		splx(s);
+		crit_exit();
 	}
 }
 
Index: kern/kern_timeout.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_timeout.c,v
retrieving revision 1.6
diff -u -r1.6 kern_timeout.c
--- kern/kern_timeout.c	26 Aug 2003 21:09:02 -0000	1.6
+++ kern/kern_timeout.c	26 Jan 2004 05:39:24 -0000
@@ -46,6 +46,7 @@
 #include <sys/kernel.h>
 #include <sys/interrupt.h>
 #include <sys/thread.h>
+#include <sys/thread2.h>
 #include <machine/ipl.h>
 
 /*
@@ -83,7 +84,6 @@
 {
 	struct callout *c;
 	struct callout_tailq *bucket;
-	int s;
 	int curticks;
 	int steps;	/* #steps since we last allowed interrupts */
 
@@ -92,7 +92,7 @@
 #endif /* MAX_SOFTCLOCK_STEPS */
 
 	steps = 0;
-	s = splhigh();
+	crit_enter();
 	while (softticks != ticks) {
 		softticks++;
 		/*
@@ -109,8 +109,8 @@
 				if (steps >= MAX_SOFTCLOCK_STEPS) {
 					nextsoftcheck = c;
 					/* Give interrupts a chance. */
-					splx(s);
-					s = splhigh();
+					crit_exit();
+					crit_enter();
 					c = nextsoftcheck;
 					steps = 0;
 				}
@@ -131,16 +131,16 @@
 					c->c_flags =
 					    (c->c_flags & ~CALLOUT_PENDING);
 				}
-				splx(s);
+				crit_exit();
 				c_func(c_arg);
-				s = splhigh();
+				crit_enter();
 				steps = 0;
 				c = nextsoftcheck;
 			}
 		}
 	}
 	nextsoftcheck = NULL;
-	splx(s);
+	crit_exit();
 }
 
 /*
Index: kern/lwkt_thread.c
===================================================================
RCS file: /cvs/src/sys/kern/lwkt_thread.c,v
retrieving revision 1.48
diff -u -r1.48 lwkt_thread.c
--- kern/lwkt_thread.c	18 Jan 2004 12:29:49 -0000	1.48
+++ kern/lwkt_thread.c	24 Jan 2004 23:56:43 -0000
@@ -1502,6 +1502,10 @@
  * us in a critical section.  The MP lock may or may not be held.
  * May also be called from doreti or splz, or be reentrantly called
  * indirectly through the ip_func[] we run.
+ *
+ * There are two versions, one where no interrupt frame is available (when
+ * called from the send code and from splz, and one where an interrupt
+ * frame is available.
  */
 void
 lwkt_process_ipiq(void)
@@ -1528,7 +1532,39 @@
 	while (ip->ip_rindex != ip->ip_windex) {
 	    ri = ip->ip_rindex & MAXCPUFIFO_MASK;
 	    ++ip->ip_rindex;
-	    ip->ip_func[ri](ip->ip_arg[ri]);
+	    ip->ip_func[ri](ip->ip_arg[ri], NULL);
+	    /* YYY memory barrier */
+	    ip->ip_xindex = ip->ip_rindex;
+	}
+    }
+}
+
+void
+lwkt_process_ipiq_frame(struct intrframe frame)
+{
+    int n;
+    int cpuid = mycpu->gd_cpuid;
+
+    for (n = 0; n < ncpus; ++n) {
+	lwkt_ipiq_t ip;
+	int ri;
+
+	if (n == cpuid)
+	    continue;
+	ip = globaldata_find(n)->gd_ipiq;
+	if (ip == NULL)
+	    continue;
+	ip = &ip[cpuid];
+
+	/*
+	 * Note: xindex is only updated after we are sure the function has
+	 * finished execution.  Beware lwkt_process_ipiq() reentrancy!  The
+	 * function may send an IPI which may block/drain.
+	 */
+	while (ip->ip_rindex != ip->ip_windex) {
+	    ri = ip->ip_rindex & MAXCPUFIFO_MASK;
+	    ++ip->ip_rindex;
+	    ip->ip_func[ri](ip->ip_arg[ri], &frame);
 	    /* YYY memory barrier */
 	    ip->ip_xindex = ip->ip_rindex;
 	}
Index: kern/subr_param.c
===================================================================
RCS file: /cvs/src/sys/kern/subr_param.c,v
retrieving revision 1.2
diff -u -r1.2 subr_param.c
--- kern/subr_param.c	17 Jun 2003 04:28:41 -0000	1.2
+++ kern/subr_param.c	25 Jan 2004 02:46:28 -0000
@@ -68,6 +68,8 @@
 #endif
 
 int	hz;
+int	stathz;
+int	profhz;
 int	tick;
 int	tickadj;			 /* can adjust 30ms in 60s */
 int	maxusers;			/* base tunable */
@@ -106,6 +108,8 @@
 {
 	hz = HZ;
 	TUNABLE_INT_FETCH("kern.hz", &hz);
+	stathz = hz * 128 / 100;
+	profhz = stathz;
 	tick = 1000000 / hz;
 	tickadj = howmany(30000, 60 * hz);	/* can adjust 30ms in 60s */
 
Index: netinet6/icmp6.c
===================================================================
RCS file: /cvs/src/sys/netinet6/icmp6.c,v
retrieving revision 1.6
diff -u -r1.6 icmp6.c
--- netinet6/icmp6.c	23 Aug 2003 11:02:45 -0000	1.6
+++ netinet6/icmp6.c	25 Jan 2004 20:26:45 -0000
@@ -2809,11 +2809,9 @@
 	int maxpps;	/* maximum pps allowed */
 {
 	struct timeval tv, delta;
-	int s, rv;
+	int rv;
 
-	s = splclock(); 
 	microtime(&tv);
-	splx(s);
 
 	timersub(&tv, lasttime, &delta);
 
Index: netproto/ns/ns_error.c
===================================================================
RCS file: /cvs/src/sys/netproto/ns/ns_error.c,v
retrieving revision 1.5
diff -u -r1.5 ns_error.c
--- netproto/ns/ns_error.c	6 Sep 2003 21:51:12 -0000	1.5
+++ netproto/ns/ns_error.c	25 Jan 2004 20:27:02 -0000
@@ -294,19 +294,6 @@
 	m_freem(m);
 }
 
-#ifdef notdef
-u_long
-nstime()
-{
-	int s = splclock();
-	u_long t;
-
-	t = (time.tv_sec % (24*60*60)) * 1000 + time.tv_usec / 1000;
-	splx(s);
-	return (htonl(t));
-}
-#endif
-
 int
 ns_echo(m)
 struct mbuf *m;
Index: pc98/pc98/clock.c
===================================================================
RCS file: /cvs/src/sys/pc98/pc98/clock.c,v
retrieving revision 1.4
diff -u -r1.4 clock.c
--- pc98/pc98/clock.c	20 Aug 2003 10:07:50 -0000	1.4
+++ pc98/pc98/clock.c	24 Jan 2004 23:31:17 -0000
@@ -166,12 +166,12 @@
 static	u_int32_t i8254_offset;
 static	int	i8254_ticked;
 /*
- * XXX new_function and timer_func should not handle clockframes, but
+ * XXX new_function and timer_func should not handle intrframes, but
  * timer_func currently needs to hold hardclock to handle the
  * timer0_state == 0 case.  We should use inthand_add()/inthand_remove()
  * to switch between clkintr() and a slightly different timerintr().
  */
-static	void	(*new_function) (struct clockframe *frame);
+static	void	(*new_function) (struct intrframe *frame);
 static	u_int	new_rate;
 #ifndef PC98
 static	u_char	rtc_statusa = RTCSA_DIVIDER | RTCSA_NOPROF;
@@ -190,7 +190,7 @@
 static 	u_char	timer1_state;
 #endif
 static	u_char	timer2_state;
-static	void	(*timer_func) (struct clockframe *frame) = hardclock;
+static	void	(*timer_func) (struct intrframe *frame) = hardclock;
 #ifdef PC98
 static void rtc_serialcombit (int);
 static void rtc_serialcom (int);
@@ -226,7 +226,7 @@
 	&i8254_timecounter, sizeof(i8254_timecounter), "S,timecounter", "");
 
 static void
-clkintr(struct clockframe frame)
+clkintr(struct intrframe frame)
 {
 	if (timecounter->tc_get_timecount == i8254_get_timecount) {
 		disable_intr();
@@ -300,7 +300,7 @@
  * The acquire and release functions must be called at ipl >= splclock().
  */
 int
-acquire_timer0(int rate, void (*function) (struct clockframe *frame))
+acquire_timer0(int rate, void (*function) (struct intrframe *frame))
 {
 	static int old_rate;
 
@@ -441,7 +441,7 @@
  * in the statistics, but the stat clock will no longer stop.
  */
 static void
-rtcintr(struct clockframe frame)
+rtcintr(struct intrframe frame)
 {
 	while (rtcin(RTC_INTR) & RTCIR_PERIOD)
 		statclock(&frame);
Index: pc98/pc98/pcaudio.c
===================================================================
RCS file: /cvs/src/sys/pc98/pc98/pcaudio.c,v
retrieving revision 1.6
diff -u -r1.6 pcaudio.c
--- pc98/pc98/pcaudio.c	20 Aug 2003 10:07:50 -0000	1.6
+++ pc98/pc98/pcaudio.c	24 Jan 2004 23:31:24 -0000
@@ -151,7 +151,7 @@
 static int pca_sleep = 0;
 static int pca_initialized = 0;
 
-static void pcaintr(struct clockframe *frame);
+static void pcaintr(struct intrframe *frame);
 
 static	d_open_t	pcaopen;
 static	d_close_t	pcaclose;
@@ -561,7 +561,7 @@
 
 
 static void
-pcaintr(struct clockframe *frame)
+pcaintr(struct intrframe *frame)
 {
 	if (pca_status.index < pca_status.in_use[pca_status.current]) {
 		disable_intr();
Index: sys/globaldata.h
===================================================================
RCS file: /cvs/src/sys/sys/globaldata.h,v
retrieving revision 1.22
diff -u -r1.22 globaldata.h
--- sys/globaldata.h	30 Dec 2003 03:19:04 -0000	1.22
+++ sys/globaldata.h	25 Jan 2004 09:02:24 -0000
@@ -47,6 +47,9 @@
 #ifndef _SYS_SLABALLOC_H_
 #include <sys/slaballoc.h> /* SLGlobalData */
 #endif
+#ifndef _SYS_SYSTIMER_H_
+#include <sys/systimer.h> /* fine-grained system timers */
+#endif
 
 /*
  * This structure maps out the global data that needs to be kept on a
@@ -93,8 +96,6 @@
 	__uint32_t	gd_other_cpus;		/* mask of 'other' cpus */
 	struct timeval	gd_stattv;
 	int		gd_intr_nesting_level;	/* (for interrupts) */
-	int		gd_psticks;		/* profile kern/kern_clock.c */
-	int		gd_psdiv;		/* profile kern/kern_clock.c */
 	struct vmmeter	gd_cnt;
 	struct lwkt_ipiq *gd_ipiq;
 	short		gd_upri;		/* userland scheduler helper */
@@ -105,6 +106,14 @@
 	int		gd_vme_kdeficit;	/* vm_map_entry reservation */
 	int		gd_vme_avail;		/* vm_map_entry reservation */
 	struct vm_map_entry *gd_vme_base;	/* vm_map_entry reservation */
+	struct systimerq gd_systimerq;		/* per-cpu system timers */
+	int		gd_syst_nest;
+	sysclock_t	gd_nextclock;		/* next best-case clock req */
+	struct systimer gd_hardclock;		/* scheduler periodic */
+	struct systimer gd_statclock;		/* statistics periodic */
+	struct systimer gd_schedclock;		/* scheduler periodic */
+	volatile __uint32_t gd_time_seconds;	/* uptime in seconds */
+	volatile sysclock_t gd_cpuclock_base;	/* cpuclock relative base */
 	/* extended by <machine/pcpu.h> */
 };
 
Index: sys/kernel.h
===================================================================
RCS file: /cvs/src/sys/sys/kernel.h,v
retrieving revision 1.7
diff -u -r1.7 kernel.h
--- sys/kernel.h	22 Nov 2003 19:30:57 -0000	1.7
+++ sys/kernel.h	25 Jan 2004 22:43:39 -0000
@@ -64,7 +64,8 @@
 extern char kernelname[MAXPATHLEN];
 
 /* 1.2 */
-extern struct timeval boottime;
+extern struct timespec boottime;
+extern struct timespec basetime;
 
 extern struct timezone tz;			/* XXX */
 
@@ -76,8 +77,9 @@
 extern int profhz;			/* profiling clock's frequency */
 extern int ticks;
 extern int lbolt;			/* once a second sleep address */
-extern int tickdelta;
-extern long timedelta;
+extern int tickdelta;			/* make this correction */
+extern long timedelta;			/* until this aggregate is exhausted */
+extern int tickpll;			/* scaled tick adjustment */
 
 #endif /* _KERNEL */
 
Index: sys/proc.h
===================================================================
RCS file: /cvs/src/sys/sys/proc.h,v
retrieving revision 1.41
diff -u -r1.41 proc.h
--- sys/proc.h	4 Jan 2004 22:14:39 -0000	1.41
+++ sys/proc.h	25 Jan 2004 04:23:04 -0000
@@ -420,7 +420,7 @@
 void	resetpriority (struct proc *);
 int	roundrobin_interval (void);
 void	resched_cpus(u_int32_t mask);
-void	schedclock (void *dummy);
+void	schedulerclock (void *dummy);
 void	setrunnable (struct proc *);
 void	clrrunnable (struct proc *, int stat);
 void	setrunqueue (struct proc *);
Index: sys/systimer.h
===================================================================
RCS file: sys/systimer.h
diff -N sys/systimer.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/systimer.h	27 Jan 2004 23:52:35 -0000
@@ -0,0 +1,58 @@
+/*
+ * SYS/SYSTIMER.H
+ */
+
+#ifndef _SYS_SYSTIMER_H_
+#define _SYS_SYSTIMER_H_
+
+struct intrframe;
+
+typedef __uint32_t	sysclock_t;
+typedef TAILQ_HEAD(systimerq, systimer) *systimerq_t;
+typedef void (*systimer_func_t)(struct systimer *info);
+typedef void (*systimer_func2_t)(struct systimer *info, struct intrframe *frame);
+
+typedef struct systimer {
+    TAILQ_ENTRY(systimer)	node;
+    systimerq_t			queue;
+    sysclock_t			time;		/* absolute time next intr */
+    sysclock_t			periodic;	/* if non-zero */
+    systimer_func2_t		func;
+    void			*data;
+    int				flags;
+    struct globaldata		*gd;		/* cpu owning structure */
+} *systimer_t;
+
+#define SYSTF_ONQUEUE		0x0001
+#define SYSTF_IPIRUNNING	0x0002
+
+void systimer_intr(sysclock_t *time, struct intrframe *frame);
+void systimer_add(systimer_t info);
+void systimer_del(systimer_t info);
+void systimer_init_periodic(systimer_t info, void *func, void *data, int hz);
+void systimer_init_oneshot(systimer_t info, void *func, void *data, int us);
+
+
+/*
+ * note that cputimer_count() always returns a full-width wrapping counter.
+ */
+sysclock_t cputimer_count(void);
+sysclock_t cputimer_fromhz(int freq);
+sysclock_t cputimer_fromus(int us);
+void cputimer_intr_reload(sysclock_t clock);
+
+/*
+ * These variables hold the fixed cputimer frequency, determining the
+ * granularity of cputimer_count().  
+ *
+ * The 64 bit versions are used for converting count values into uS or nS
+ * as follows:
+ *
+ *	usec = (cputimer_freq64_usec * count) >> 32
+ */
+extern sysclock_t cputimer_freq;	/* in Hz */
+extern int64_t cputimer_freq64_usec;	/* in (1e6 << 32) / timer_freq */
+extern int64_t cputimer_freq64_nsec;	/* in (1e9 << 32) / timer_freq */
+
+#endif
+
Index: sys/systm.h
===================================================================
RCS file: /cvs/src/sys/sys/systm.h,v
retrieving revision 1.16
diff -u -r1.16 systm.h
--- sys/systm.h	15 Nov 2003 21:05:43 -0000	1.16
+++ sys/systm.h	25 Jan 2004 08:18:22 -0000
@@ -104,7 +104,7 @@
  * General function declarations.
  */
 
-struct clockframe;
+struct intrframe;
 struct malloc_type;
 struct proc;
 struct xwait;
@@ -186,8 +186,6 @@
 
 void	realitexpire (void *);
 void	DELAY(int usec);
-void	hardclock (struct clockframe *frame);
-void	statclock (struct clockframe *frame);
 
 void	startprofclock (struct proc *);
 void	stopprofclock (struct proc *);
Index: sys/thread.h
===================================================================
RCS file: /cvs/src/sys/sys/thread.h,v
retrieving revision 1.39
diff -u -r1.39 thread.h
--- sys/thread.h	18 Jan 2004 12:29:50 -0000	1.39
+++ sys/thread.h	24 Jan 2004 23:54:42 -0000
@@ -62,6 +62,11 @@
 #ifndef _MACHINE_THREAD_H_
 #include <machine/thread.h>		/* md_thread */
 #endif
+#ifndef _MACHINE_FRAME_H_
+#include <machine/frame.h>
+#endif
+#else
+struct intrframe;
 #endif
 
 /*
@@ -90,13 +95,19 @@
 #define MAXCPUFIFO      16	/* power of 2 */
 #define MAXCPUFIFO_MASK	(MAXCPUFIFO - 1)
 
+/*
+ * Always cast to ipifunc_t when registering an ipi.  The actual ipi function
+ * is called with both the data and an interrupt frame, but the ipi function
+ * that is registered might only declare a data argument.
+ */
 typedef void (*ipifunc_t)(void *arg);
+typedef void (*ipifunc2_t)(void *arg, struct intrframe *frame);
 
 typedef struct lwkt_ipiq {
     int		ip_rindex;      /* only written by target cpu */
     int		ip_xindex;      /* writte by target, indicates completion */
     int		ip_windex;      /* only written by source cpu */
-    ipifunc_t	ip_func[MAXCPUFIFO];
+    ipifunc2_t	ip_func[MAXCPUFIFO];
     void	*ip_arg[MAXCPUFIFO];
 } lwkt_ipiq;
 
@@ -284,6 +295,9 @@
 extern void lwkt_send_ipiq_mask(u_int32_t mask, ipifunc_t func, void *arg);
 extern void lwkt_wait_ipiq(int dcpu, int seq);
 extern void lwkt_process_ipiq(void);
+#ifdef _KERNEL
+extern void lwkt_process_ipiq_frame(struct intrframe frame);
+#endif
 extern void crit_panic(void);
 extern struct proc *lwkt_preempted_proc(void);
 
Index: sys/time.h
===================================================================
RCS file: /cvs/src/sys/sys/time.h,v
retrieving revision 1.7
diff -u -r1.7 time.h
--- sys/time.h	7 Jan 2004 11:04:20 -0000	1.7
+++ sys/time.h	27 Jan 2004 06:46:22 -0000
@@ -82,86 +82,6 @@
 #define	DST_EET		5	/* Eastern European dst */
 #define	DST_CAN		6	/* Canada */
 
-/*
- * Structure used to interface to the machine dependent hardware support
- * for timekeeping.
- *
- * A timecounter is a (hard or soft) binary counter which has two properties:
- *    * it runs at a fixed, known frequency.
- *    * it must not roll over in less than (1 + delta)/HZ seconds.  "delta"
- *	is expected to be less than 20 msec, but no hard data has been 
- *      collected on this.  16 bit at 5 MHz (31 msec) is known to work.
- *
- * get_timecount() reads the counter.
- *
- * counter_mask removes unimplemented bits from the count value.
- *
- * frequency is the counter frequency in hz.
- *
- * name is a short mnemonic name for this counter.
- *
- * cost is a measure of how long time it takes to read the counter.
- *
- * adjustment [PPM << 16] which means that the smallest unit of correction
- *     you can apply amounts to 481.5 usec/year.
- *
- * scale_micro [2^32 * usec/tick].
- * scale_nano_i [ns/tick].
- * scale_nano_f [(ns/2^32)/tick].
- *
- * offset_count is the contents of the counter which corresponds to the
- *     rest of the offset_* values.
- *
- * offset_sec [s].
- * offset_micro [usec].
- * offset_nano [ns/2^32] is misnamed, the real unit is .23283064365...
- *     attoseconds (10E-18) and before you ask: yes, they are in fact 
- *     called attoseconds, it comes from "atten" for 18 in Danish/Swedish.
- *
- * Each timecounter must supply an array of three timecounters, this is needed
- * to guarantee atomicity in the code.  Index zero is used to transport 
- * modifications, for instance done with sysctl, into the timecounter being 
- * used in a safe way.  Such changes may be adopted with a delay of up to 1/HZ,
- * index one & two are used alternately for the actual timekeeping.
- *
- * 'tc_avail' points to the next available (external) timecounter in a
- *      circular queue.  This is only valid for index 0.
- *
- * `tc_other' points to the next "work" timecounter in a circular queue,
- *      i.e., for index i > 0 it points to index 1 + (i - 1) % NTIMECOUNTER.
- *      We also use it to point from index 0 to index 1.
- *
- * `tc_tweak' points to index 0.
- */
-
-struct timecounter;
-typedef unsigned timecounter_get_t (struct timecounter *);
-typedef void timecounter_pps_t (struct timecounter *);
-
-struct timecounter {
-	/* These fields must be initialized by the driver. */
-	timecounter_get_t	*tc_get_timecount;
-	timecounter_pps_t	*tc_poll_pps;
-	unsigned 		tc_counter_mask;
-	u_int32_t		tc_frequency;
-	char			*tc_name;
-	void			*tc_priv;
-	/* These fields will be managed by the generic code. */
-	int64_t			tc_adjustment;
-	u_int32_t		tc_scale_micro;
-	u_int32_t		tc_scale_nano_i;
-	u_int32_t		tc_scale_nano_f;
-	unsigned 		tc_offset_count;
-	u_int32_t		tc_offset_sec;
-	u_int32_t		tc_offset_micro;
-	u_int64_t		tc_offset_nano;
-	struct timeval		tc_microtime;
-	struct timespec		tc_nanotime;
-	struct timecounter	*tc_avail;
-	struct timecounter	*tc_other;
-	struct timecounter	*tc_tweak;
-};
-
 #ifdef _KERNEL
 
 /* Operations on timespecs */
@@ -269,14 +189,13 @@
 #endif
 
 #ifdef _KERNEL
-extern struct timecounter *timecounter;
 extern time_t	time_second;
 
+void	initclocks_pcpu(void);
 void	getmicrouptime (struct timeval *tv);
 void	getmicrotime (struct timeval *tv);
 void	getnanouptime (struct timespec *tv);
 void	getnanotime (struct timespec *tv);
-void	init_timecounter (struct timecounter *tc);
 int	itimerdecr (struct itimerval *itp, int usec);
 int	itimerfix (struct timeval *tv);
 int 	ppsratecheck (struct timeval *, int *, int usec);
@@ -285,12 +204,11 @@
 void	microtime (struct timeval *tv);
 void	nanouptime (struct timespec *ts);
 void	nanotime (struct timespec *ts);
-void	set_timecounter (struct timespec *ts);
+void	set_timeofday(struct timespec *ts);
 void	timevaladd (struct timeval *, struct timeval *);
 void	timevalsub (struct timeval *, struct timeval *);
 int	tvtohz_high (struct timeval *);
 int	tvtohz_low (struct timeval *);
-void	update_timecounter (struct timecounter *tc);
 #else /* !_KERNEL */
 #include <time.h>
 
Index: sys/timepps.h
===================================================================
RCS file: /cvs/src/sys/sys/timepps.h,v
retrieving revision 1.3
diff -u -r1.3 timepps.h
--- sys/timepps.h	20 Aug 2003 07:31:21 -0000	1.3
+++ sys/timepps.h	25 Jan 2004 01:32:44 -0000
@@ -17,6 +17,7 @@
 #define _SYS_TIMEPPS_H_
 
 #include <sys/ioccom.h>
+#include <sys/systimer.h>
 
 #define PPS_API_VERS_1	1
 
@@ -109,11 +110,10 @@
 	pps_info_t	ppsinfo;
 	int		kcmode;
 	int		ppscap;
-	struct timecounter *ppstc;
-	unsigned	ppscount[3];
+	sysclock_t	ppscount[3];
 };
 
-void pps_event (struct pps_state *pps, struct timecounter *tc, unsigned count, int event);
+void pps_event (struct pps_state *pps, sysclock_t count, int event);
 void pps_init (struct pps_state *pps);
 int pps_ioctl (u_long cmd, caddr_t data, struct pps_state *pps);
 void hardpps (struct timespec *tsp, long nsec);
Index: sys/timex.h
===================================================================
RCS file: /cvs/src/sys/sys/timex.h,v
retrieving revision 1.3
diff -u -r1.3 timex.h
--- sys/timex.h	20 Aug 2003 07:31:21 -0000	1.3
+++ sys/timex.h	26 Jan 2004 04:34:27 -0000
@@ -221,9 +221,11 @@
 #ifdef __FreeBSD__
 
 #ifdef _KERNEL
-struct timecounter;
-void	ntp_update_second (struct timecounter *tc);
-#else /* !_KERNEL */
+
+int   ntp_update_second (time_t, int64_t *);
+
+#else
+
 #include <sys/cdefs.h>
 
 __BEGIN_DECLS
Index: vfs/nfs/nfs_serv.c
===================================================================
RCS file: /cvs/src/sys/vfs/nfs/nfs_serv.c,v
retrieving revision 1.11
diff -u -r1.11 nfs_serv.c
--- vfs/nfs/nfs_serv.c	9 Oct 2003 22:27:26 -0000	1.11
+++ vfs/nfs/nfs_serv.c	25 Jan 2004 08:39:16 -0000
@@ -136,7 +136,7 @@
 int nfsrvw_procrastinate = NFS_GATHERDELAY * 1000;
 int nfsrvw_procrastinate_v3 = 0;
 
-static struct timeval	nfsver = { 0 };
+static struct timespec	nfsver;
 
 SYSCTL_DECL(_vfs_nfs);
 
@@ -1196,7 +1196,7 @@
 		if (nfsver.tv_sec == 0)
 			nfsver = boottime;
 		*tl++ = txdr_unsigned(nfsver.tv_sec);
-		*tl = txdr_unsigned(nfsver.tv_usec);
+		*tl = txdr_unsigned(nfsver.tv_nsec / 1000);
 	} else {
 		nfsm_build(fp, struct nfs_fattr *, NFSX_V2FATTR);
 		nfsm_srvfillattr(vap, fp);
@@ -1484,7 +1484,7 @@
 			    if (nfsver.tv_sec == 0)
 				    nfsver = boottime;
 			    *tl++ = txdr_unsigned(nfsver.tv_sec);
-			    *tl = txdr_unsigned(nfsver.tv_usec);
+			    *tl = txdr_unsigned(nfsver.tv_nsec / 1000);
 			} else {
 			    nfsm_build(fp, struct nfs_fattr *, NFSX_V2FATTR);
 			    nfsm_srvfillattr(&va, fp);
@@ -3694,7 +3694,7 @@
 		if (nfsver.tv_sec == 0)
 			nfsver = boottime;
 		*tl++ = txdr_unsigned(nfsver.tv_sec);
-		*tl = txdr_unsigned(nfsver.tv_usec);
+		*tl = txdr_unsigned(nfsver.tv_nsec / 1000);
 	} else {
 		error = 0;
 	}
Index: vfs/nfs/nfs_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/nfs/nfs_vfsops.c,v
retrieving revision 1.10
diff -u -r1.10 nfs_vfsops.c
--- vfs/nfs/nfs_vfsops.c	15 Nov 2003 21:05:44 -0000	1.10
+++ vfs/nfs/nfs_vfsops.c	25 Jan 2004 08:41:23 -0000
@@ -409,8 +409,8 @@
 	 * XXX time must be non-zero when we init the interface or else
 	 * the arp code will wedge...
 	 */
-	while (time_second == 0)
-		tsleep(&time_second, 0, "arpkludge", 10);
+	while (mycpu->gd_time_seconds == 0)
+		tsleep(mycpu, 0, "arpkludge", 10);
 
 	if (nfs_diskless_valid==1) 
 	  nfs_convert_diskless();
Index: vfs/nfs/nfs_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/nfs/nfs_vnops.c,v
retrieving revision 1.16
diff -u -r1.16 nfs_vnops.c
--- vfs/nfs/nfs_vnops.c	23 Jan 2004 23:00:52 -0000	1.16
+++ vfs/nfs/nfs_vnops.c	25 Jan 2004 08:41:41 -0000
@@ -301,7 +301,7 @@
 		rmode = fxdr_unsigned(u_int32_t, *tl);
 		np->n_mode = rmode;
 		np->n_modeuid = cred->cr_uid;
-		np->n_modestamp = time_second;
+		np->n_modestamp = mycpu->gd_time_seconds;
 	}
 	m_freem(mrep);
 nfsmout:
@@ -382,7 +382,7 @@
 		 * Does our cached result allow us to give a definite yes to
 		 * this request?
 		 */
-		if ((time_second < (np->n_modestamp + nfsaccess_cache_timeout)) &&
+		if ((mycpu->gd_time_seconds < (np->n_modestamp + nfsaccess_cache_timeout)) &&
 		    (ap->a_cred->cr_uid == np->n_modeuid) &&
 		    ((np->n_mode & mode) == mode)) {
 			nfsstats.accesscache_hits++;
